<script lang="ts" setup>
import { ref, computed, resolveComponent } from 'vue';

const componentMap = {
  Devsurvey2024BubbleTable: resolveComponent('Devsurvey2024BubbleTable'),
  Devsurvey2024ResultsRadio: resolveComponent('Devsurvey2024ResultsRadio'),
  Devsurvey2024TextResults: resolveComponent('Devsurvey2024TextResults'),
};

export interface Carousel {
  title?: string;
  config?: {
    type: string;
    gaLocation: string;
  };
  buttons: {
    previous: string;
    next: string;
  };
  blocks: [
    {
      header: string;
      text: string;
    },
  ];
}

const props = defineProps({
  data: {
    type: Object as () => Carousel,
    required: true,
    default: () => ({}),
  },
  controlsOnTop: {
    type: Boolean,
    required: false,
    default: false,
  },
  components: {
    type: Object,
    required: false,
    default: () => ({}),
  },
});

const currentSlide = ref(0);

const slideCount = computed(() => {
  if (props.components?.data?.length) {
    return props.components.data.length;
  } else if (props.data?.blocks?.length) {
    return props.data.blocks.length;
  }
  return 0;
});

const buttonGaName = computed(() => {
  const currentBlock = props.data.blocks?.[currentSlide.value];
  const currentComponent = props.components?.data?.[currentSlide.value];

  if (currentBlock) {
    return (currentBlock.header || currentBlock.dataGaName || '').toLowerCase().replace(/[\r\n]+$/, '');
  }

  if (currentComponent?.header) {
    return currentComponent.header.toLowerCase().replace(/[\r\n]+$/, '');
  }

  return '';
});

const prevSlide = () => {
  currentSlide.value = currentSlide.value > 0 ? currentSlide.value - 1 : slideCount.value - 1;
};

const nextSlide = () => {
  currentSlide.value = currentSlide.value < slideCount.value - 1 ? currentSlide.value + 1 : 0;
};
</script>

<template>
  <div class="survey-carousel" :class="{ inverse: controlsOnTop }">
    <transition-group
      v-if="data.blocks && data.blocks.length"
      name="slide-fade"
      tag="div"
      class="slides"
      aria-live="polite"
    >
      <div
        v-for="(item, index) in data.blocks"
        v-show="index === currentSlide"
        :key="item.header || item.text"
        class="slide"
      >
        <SlpTypography v-if="item.header" variant="heading5-bold" tag="p" class="slp-mb-8">
          {{ item.header }}
        </SlpTypography>
        <SlpTypography variant="body2" tag="div">
          <div class="slide__text" v-html="$md.render(item.text)" />
        </SlpTypography>
      </div>
    </transition-group>
    <div v-else class="slides">
      <div
        v-for="(component, index) in components.data"
        v-show="index === currentSlide"
        :key="`${components.type || component.config?.name}-${index}`"
        class="slide"
      >
        <component
          :is="componentMap[component.config?.name || components.type]"
          :key="`${Math.random()}`"
          :data="component || components.data"
        />
      </div>
    </div>
    <div class="controls">
      <button
        class="button"
        aria-label="Previous slide"
        :data-ga-name="`previous - ${buttonGaName}`"
        :data-ga-location="data.config?.gaLocation || 'body'"
        @click="prevSlide"
      >
        {{ data.buttons.previous }}
      </button>
      <div class="progress">
        <div>{{ currentSlide + 1 }}/{{ slideCount }}</div>
      </div>
      <button
        class="button"
        aria-label="Next slide"
        :data-ga-name="`next - ${buttonGaName}`"
        :data-ga-location="data.config?.gaLocation || 'body'"
        @click="nextSlide"
      >
        {{ data.buttons.next }}
      </button>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.survey-carousel {
  background: #f6f3fe;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  height: 100%;

  &.inverse {
    flex-direction: column-reverse;
  }

  .slides {
    position: relative;
    flex-grow: 1;
    min-height: 200px;
    height: 100%;
    display: flex;
    align-items: center;
    overflow: hidden;
  }

  .controls {
    display: flex;
    justify-content: space-between;
    align-items: center;
    margin-top: 16px;
    flex-shrink: 0;

    .button {
      flex-grow: 1;
      width: 100%;
      outline: none;
      border: none;
      font-family: 'GitLab Mono';
      font-size: 14px;
      display: inline-flex;
      align-items: center;
      background: #2f2a6b;
      border-radius: 999px;
      color: #fdf1dd;
      padding: 4px 16px;
      text-align: center;
      justify-content: center;
      cursor: pointer;
      transition: background 0.2s ease-in-out;

      &:focus-visible {
        outline-style: solid;
        outline-color: #5943b6;
      }

      &:hover {
        background: #5943b6;
      }
    }

    .progress {
      flex-grow: 1;
      padding: 0 16px;
      text-align: center;
      font-family: 'GitLab Mono';
    }
  }

  .slide {
    width: 100%;
    flex-shrink: 0;
    display: flex;
    flex-direction: column;
  }

  .slide:deep(.survey-results-radio) {
    margin-top: 24px;
  }

  .slide__text {
    &:deep(.stat),
    &:deep(.number) {
      font-family: 'GitLab Mono';
      font-size: 80px;
      line-height: 80px;
    }

    &:deep(.orange) {
      color: #fc6d26;
    }

    &:deep(.teal) {
      color: #10b1b1;
    }

    &:deep(.red) {
      color: #e24329;
    }

    &:deep(.purple) {
      color: #7759c2;
    }
  }
}

.slide-fade-enter-active,
.slide-fade-leave-active {
  transition: opacity 0.3s;
}

.slide-fade-enter,
.slide-fade-leave-to {
  opacity: 0;
}
</style>
